WITH   Ada.Unchecked_Conversion ;
WITH   Interfaces.C ;
WITH   Stdarg ;
WITH   System ;
WITH   Win32 ;
WITH   Win32.Crt.Strings ;
WITH   Win32.Windef ;
WITH   Win32.Wingdi ;
WITH   Win32.Winuser ;

PACKAGE BODY   PM2x2_Pkg  IS

   FUNCTION   CP   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPCSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPCSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CP;

   FUNCTION   CPS   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CPS;

   USE TYPE   Win32.CHAR_Array ;      --- To get "&"

   Nul : Win32.Char RENAMES Win32.Nul ;

   IgnoredI : Win32.INT ;

   C_MainPMTitle : CONSTANT Win32.CHAR_Array := "Information"  &  Nul ;
   C_MainNbFmt   : CONSTANT Win32.CHAR_Array := "%.ld"  &  Nul ;

   L_Buf25 : ALIASED Win32.CHAR_Array(0..25);

   MyNum : Win32.LONG ;

   PROCEDURE   ShowPM2x2  IS
      USE TYPE   Interfaces.C.Long ;

      FUNCTION   "&"  IS  new Stdarg.Concat ( Win32.LONG );
   BEGIN
      MyNum := 2 + 2 ;

      IgnoredI := Win32.Winuser.wvsprintf ( CPS(L_Buf25) , CP(C_MainNbFmt)
                                          , Stdarg.Empty
                                           &Win32.LONG(MyNum)
                                          );

      IgnoredI := Win32.Winuser.MessageBox ( System.Null_address
                                           , CP(L_Buf25)
                                           , CP(C_MainPMTitle)
                                           , Win32.Winuser.MB_OK or Win32.Winuser.MB_ICONEXCLAMATION );

   END ShowPM2x2;

END PM2x2_Pkg;
