WITH   Ada.Unchecked_Conversion ;
WITH   Interfaces.C ;
WITH   System ;
WITH   Win32 ;
WITH   Win32.Crt.Strings ;
WITH   Win32.Windef ;
WITH   Win32.Wingdi ;
WITH   Win32.Winuser ;

PACKAGE BODY   PMHello5_Pkg  IS

   FUNCTION   CP   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPCSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPCSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CP;

   FUNCTION   CPS   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CPS;

   FUNCTION   To_IntW  IS  new Ada.Unchecked_Conversion(Win32.PCHAR, Integer);
   FUNCTION   To_PCHAR  IS  new Ada.Unchecked_Conversion(Integer, Win32.PCHAR);

   USE TYPE   Win32.CHAR_Array ;      --- To get "&"

   Nul : Win32.Char RENAMES Win32.Nul ;

   IgnoredI : Win32.INT ;
   IgnoredP : Win32.PSTR ;

   C_MainPMTitle : CONSTANT Win32.CHAR_Array := "Information"  &  Nul ;
   C_MainPMMsg   : CONSTANT Win32.CHAR_Array := "Hello World....."  &  Nul ;
   CRLFz : CONSTANT Win32.CHAR_Array := Win32.Char(Character'Val(13))  &  Win32.Char(Character'Val(10))  &  Nul ;

   L_Buffer : ALIASED Win32.CHAR_Array(0..255);

   PROCEDURE   ShowPMHello5  IS
      L_P : Win32.LPSTR ;
      L_TmpLen : Standard.INTEGER ;
   BEGIN
      L_P := CPS(L_Buffer);

      IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_MainPMMsg) );
      IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
      L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
      L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

      IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_MainPMMsg) );
      IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
      L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
      L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

      IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_MainPMMsg) );
      IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
      L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
      L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

      IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_MainPMMsg) );
      IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
      L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
      L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

      IgnoredP := Win32.Crt.Strings.StrCpy ( L_P , CP(C_MainPMMsg) );
      IgnoredP := Win32.Crt.Strings.StrCat ( L_P , CP(CRLFz) );
      L_TmpLen := Standard.INTEGER( Win32.Crt.Strings.StrLen(Win32.PCCH(L_P)) );
      L_P      := To_PCHAR(To_IntW(L_P) + L_TmpLen);

      IgnoredI := Win32.Winuser.MessageBox ( System.Null_Address
                                           , CP(L_Buffer)
                                           , CP(C_MainPMTitle)
                                           , Win32.Winuser.MB_OK or Win32.Winuser.MB_ICONEXCLAMATION );
   END ShowPMHello5;

END PMHello5_Pkg;
